// copyright 2007 Dean Laforet, Simon Paterson
// do not use or modify code without permission.

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

var winPath = System.Environment.getEnvironmentVariable("WINDIR");
var pfPath = System.Environment.getEnvironmentVariable("PROGRAMFILES");
if (oFSO.FolderExists(pfPath+" (x86)")) pfPath += " (x86)";
var	myComp = winPath+"\\explorer.exe";
var	control = winPath+"\\system32\\control.exe";
var	ie = pfPath+"\\Internet Explorer\\iexplore.exe";
var gadgetPath = System.Gadget.path;
var network = gadgetPath+"\\images\\network.ico";
var rbEmpty = gadgetPath+"\\images\\rbEmpty.ico";
var rbFull = gadgetPath+"\\images\\rbFull.ico";
var makeIconBigger = "yes";
var showHighlight = "no";
var cancelBodyOver = 0;
var	linksList = new Array();
var iconsList = new Array();
var switchList = new Array();

var bDebug = oFSO.FileExists(gadgetPath+"\\debug.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debug.txt", 2);
} catch(err) {bDebug = false;}

function debugLog(outStr) 
{
try{
		System.Debug.outputString(outStr);
		if (bDebug)
			debugLogFile.WriteLine(outStr);
} catch(err) {}
}

onerror = function(msg,url,l) 
{
	debugLog("Javascript error: "+msg+" - on line: "+l);
}

document.onreadystatechange = function()
{
try{
  if(document.readyState=="complete")
  {
    System.Gadget.settingsUI = "settings.html";
    System.Gadget.onSettingsClosed = settingsClosed;
    setRbIcons();
    System.Shell.RecycleBin.onRecycleBinChanged = updateRB;
    getSettings();
    createLayout();
  }        
} catch(err) {debugLog("onreadystatechange: "+err.name+" - "+err.message)}
}

function read(name)
{
  value = System.Gadget.Settings.read(name);
  return value;
}

function write(name,value)
{
  System.Gadget.Settings.write(name, value);
}

function getSettings()
{
try{
	if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\filepaths.txt")) 
	{
		var defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\filepaths.txt", 1, false);
		try
		{
			var index = 0;
			for (var i = 0; !defaultFile.AtEndOfStream; i++)
			{
				testLink = defaultFile.ReadLine();
				
				if (testLink == "My Computer" || testLink == "Control Panel Category" || testLink == "Control Panel Classic" || testLink == "Control Panel VAIO" || testLink == "Internet Explorer" || testLink == "Recycle Bin" || testLink == "Network" || testLink == "Network VAIO" || testLink == "IE Favorites" || testLink == "Firefox Bookmarks" || testLink == "Opera Bookmarks" || testLink == "LauncherDivider")
				{
					isGood = true;
				}
				else
        {
          if(isValidPath(testLink))
          {
            if (oFSO.FileExists(testLink)) isGood = true;
            else if (oFSO.FolderExists(testLink)) isGood = true;
            else isGood = false;
					}
					else
					{
            isGood = false;
					}
				}
				
				if (isGood)
				{
          linksList[index] = testLink;
					index++;
				}
			}
			defaultFile.Close();
		}	catch(err) {debugLog("Open filepaths.txt error"+err.name+" - "+err.message)}
	}
	else
	{
		linksList[0] = "My Computer";
		linksList[1] = "Control Panel Classic";
		linksList[2] = "Internet Explorer";
		linksList[3] = "Recycle Bin";
	}
		
	if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\iconpaths.txt")) 
	{
    var defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\iconpaths.txt", 1, false);
    for (var i = 0; !defaultFile.AtEndOfStream; i++)
    {
      iconsList[i] = defaultFile.ReadLine();
    }
    defaultFile.Close();
  }
  
  for (var i=iconsList.length; i<linksList.length; i++)
  {
    iconsList[i] = "none";
  }

	if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\switchpaths.txt")) 
	{
    var defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\switchpaths.txt", 1, false);
    for (var i = 0; !defaultFile.AtEndOfStream; i++)
    {
      switchList[i] = defaultFile.ReadLine();
    }
    defaultFile.Close();
  }
  
  for (var i=switchList.length; i<linksList.length; i++)
  {
    switchList[i] = "none";
  }
							
  write("Links", linksList.toString());
  write("Icons", iconsList.toString());
  write("Switches", switchList.toString());

  targetLink = 1;
  perRowSetting = 1;
  dragSetting = 0;
  bgSetting = 19;
  infoSetting = 1;
  folderSetting = 0;
  centreSetting = 0;
  settingsTipsSetting = 0;
  folderOpenSetting = 1;
  filterExtSetting = 1;

  write("TargetLink", targetLink);
  write("PerRowSetting", perRowSetting);
  write("DragSetting", dragSetting);
  write("BgSetting", bgSetting);
  write("InfoSetting", infoSetting);
  write("FolderSetting", folderSetting);
  write("CentreSetting", centreSetting);
  write("SettingsTipsSetting", settingsTipsSetting);
  write("FolderOpenSetting", folderOpenSetting);
  write("FilterExtSetting", filterExtSetting);
  
  if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\settings.txt"))
  {	
    defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\settings.txt", 1, false);
    targetLink = defaultFile.ReadLine();
    write("TargetLink", targetLink);
    if (defaultFile.AtEndOfStream) return;
    perRowSetting = defaultFile.ReadLine();
    write("PerRowSetting", perRowSetting);
    if (defaultFile.AtEndOfStream) return;
    dragSetting = defaultFile.ReadLine();
    write("DragSetting", dragSetting);
    if (defaultFile.AtEndOfStream) return;
    bgSetting = defaultFile.ReadLine();
    write("BgSetting", bgSetting);
    if (defaultFile.AtEndOfStream) return;
    infoSetting = defaultFile.ReadLine();
    write("InfoSetting", infoSetting);
    if (defaultFile.AtEndOfStream) return;
    folderSetting = defaultFile.ReadLine();
    write("FolderSetting", folderSetting);
    if (defaultFile.AtEndOfStream) return;
    centreSetting = defaultFile.ReadLine();
    write("CentreSetting", centreSetting);
    if (defaultFile.AtEndOfStream) return;
    settingsTipsSetting = defaultFile.ReadLine();
    write("SettingsTipsSetting", settingsTipsSetting);
    if (defaultFile.AtEndOfStream) return;
    folderOpenSetting = defaultFile.ReadLine();
    write("FolderOpenSetting", folderOpenSetting);
    if (defaultFile.AtEndOfStream) return;
    filterExtSetting = defaultFile.ReadLine();
    write("FilterExtSetting", filterExtSetting);
    defaultFile.Close();
  }

}catch(err) {debugLog("GetSettings: "+err.name+" - "+err.message)}
}

function createLayout()
{
try{
  System.Gadget.background = "/images/backgrounds/bg" + bgSetting + ".jpg"; 
	
	if (infoSetting == 1)
	{
    document.getElementById("appInfo").style.display="";
    bottomPadding = 19;
	}
	else
	{
    document.getElementById("appInfo").style.display="none";
    bottomPadding = 6;
	}
	
	if (perRowSetting == 0)
	{
		perRow = 3;
		imgSmall = 32;
		imgLarge = 38;
    wh = "?width=32&height=32";
		cellSize = 40;
    document.body.style.marginTop = "2px";
    if (linksList.length < 4 && infoSetting == 0)
    {
      document.body.style.marginTop = "4px";
    }
	}
	else
	{
		perRow = 4;
		imgSmall = 24;
		imgLarge = 28;
    wh = "?width=24&height=24";
		cellSize = 30;
		if (linksList.length < 5)
		{
      document.body.style.marginTop = "9px";
		}
		else
		{
      document.body.style.marginTop = "2px";
		}
	}
	
	var imgCounter = 1;
	var rowCounter = 1;
	
	outputDIV.innerHTML = "";

  var oTable = document.createElement("table");
  oTable.className = "launcherTable";
  oTable.setAttribute("cellPadding",0);
  oTable.setAttribute("cellSpacing",0);
  oTable.setAttribute("border",0);
  row = oTable.insertRow();
  row.className = "launcherRow";

	for (var i=0; i < linksList.length; ++i)
	{
		setFilePaths(i);
		
		if (thisPath != "LauncherDivider")
		{
      src = "gimage:///" + src + wh;

      cell = row.insertCell();
      cell.id = "cell"+i;
      cell.className = "cell";
      cell.width = cellSize;
      cell.height = cellSize;
      var oImg = document.createElement("img");
      oImg.width = imgSmall;
      oImg.height = imgSmall;
      oImg.setAttribute("link",thisPath);
      oImg.id = imageID;
      oImg.src = src;
      oImg.onclick = new Function(""+execType+"");
      oImg.onmouseover = new Function("hiliteLink(0)");
      oImg.onmouseout = new Function("unHiliteLink(0)");
      oImg.ondragenter = new Function(""+dragEnter+"");
      oImg.ondragover = new Function(""+dragOver+"");
      oImg.ondragleave = new Function(""+dragLeave+"");
      oImg.ondrop = new Function(""+dragDrop+"");
      cell.appendChild(oImg);
      
      if (imgCounter == perRow && i != (linksList.length-1))
      {
        imgCounter = 0;
        outputDIV.appendChild(oTable);
        if (linksList[(i+1)] != "LauncherDivider")
        {
          var oTable = document.createElement("table");
          oTable.className = "launcherTable";
          oTable.setAttribute("cellPadding",0);
          oTable.setAttribute("cellSpacing",0);
          oTable.setAttribute("border",0);
          row = oTable.insertRow();
          row.className = "launcherRow";

          rowCounter++;
        }
      }
      imgCounter++;
		}
		else
		{
      if (imgCounter != 1)
      {
        if (centreSetting == 1)
        {
          for (var j=imgCounter ; j <= perRow ; j++)
          {
            cell = row.insertCell();
            cell.className = "emptyCell";
            cell.width = cellSize;
            cell.height = cellSize;
            cell.innerHTML = "&nbsp;";
          }
        } 
        outputDIV.appendChild(oTable);
      }
      
      var oTable = document.createElement("table");
      oTable.className = "launcherTable";
      oTable.setAttribute("cellPadding",0);
      oTable.setAttribute("cellSpacing",0);
      oTable.setAttribute("border",0);
      row = oTable.insertRow();
      row.className = "divider";
      cell = row.insertCell();
      var oImg = document.createElement("img");
      oImg.src = src;
      cell.appendChild(oImg);
      outputDIV.appendChild(oTable);

      bottomPadding += 2;
      imgCounter = 1;
      if (i != (linksList.length-1))
      {
        var oTable = document.createElement("table");
        oTable.className = "launcherTable";
        oTable.setAttribute("cellPadding",0);
        oTable.setAttribute("cellSpacing",0);
        oTable.setAttribute("border",0);
        row = oTable.insertRow();
        row.className = "launcherRow";
        
        rowCounter++;
      }
		}
  }

  if (imgCounter != 1 && centreSetting == 1)
  {
    for (var i=imgCounter ; i <= perRow ; i++)
    {
      cell = row.insertCell();
      cell.className = "emptyCell";
      cell.width = cellSize;
      cell.height = cellSize;
      cell.innerHTML = "&nbsp;";
    }
  }
	
  outputDIV.appendChild(oTable);
	
	document.body.style.height = (rowCounter*cellSize)+bottomPadding+"px"; 
	
	updateRB();
} catch(err) {debugLog("CreateLayout: "+err.name+" - "+err.message);}
}

function setFilePaths(i)
{
try{
	imageID = "img"+i;
	thisPath = linksList[i];
		
  thisTitle = oFSO.GetFileName(thisPath);
		
  execType = "execLink()";
	
	dragEnter = "javascript:event.returnValue = false";
	dragOver = "javascript:event.returnValue = false";
	dragLeave = "javascript:event.returnValue = false";
	dragDrop = "javascript:event.returnValue = false";
	
	tmpPath = thisPath;

	fileExtension = oFSO.GetExtensionName(thisPath).toLowerCase();
	if (fileExtension == "lnk")
	{
		oLink = oShell.CreateShortcut(thisPath);
		tmpPath = oLink.TargetPath;
		if (targetLink == 0)
		{
			if (oFSO.GetFileName(tmpPath).toLowerCase() != "hlsw.exe")
			{
				thisPath = tmpPath;
				linksList[i] = thisPath;
				write("Links", linksList.toString());
			}
		}
		else if (targetLink == 2) 
		{ 
      tmpPath = thisPath;
      theIconLocation = oLink.iconLocation;
      if ((theIconLocation.length >= 2) && (theIconLocation.substr(theIconLocation.length - 2).toLowerCase() == ",0"))
      {
        tmpPath = theIconLocation.substr(0, (theIconLocation.length - 2));
        if (tmpPath== "")
        {
           tmpPath = oLink.targetPath;
        }
      }
		}
		else{}
	}
		
	if (thisTitle=="iTunesIco.exe" || thisTitle=="iTunes.lnk")
	{
    iTunesPath = pfPath + "\\iTunes\\iTunes.exe";
    if (oFSO.FileExists(iTunesPath))
    {
      linksList[i] = iTunesPath;
      write("Links", linksList.toString());
		}
	}

	if (thisPath == "My Computer")
	{
		src = myComp;
	}
	else if (thisPath == "Network")
	{
		src = network;
	}
	else if (thisPath == "Network VAIO")
	{
		src = network;
	}
	else if (thisPath == "Control Panel Category")
	{
		src = control;
	}
	else if (thisPath == "Control Panel Classic")
	{
		src = control;
	}
	else if (thisPath == "Control Panel VAIO")
	{
		src = control;
	}
	else if (thisPath == "Internet Explorer")
	{
		src = ie;
	}
	else if (thisPath == "Recycle Bin")
	{
		src = rbEmpty;
		imageID = "rbHere";    
		dragEnter = "javascript:event.returnValue = false";
		dragOver = "hiliteLink(1);javascript:event.returnValue = false";
		dragLeave = "unHiliteLink(1);javascript:event.returnValue = false";
		dragDrop = "recycleBinDragDropped()";
		execType = "recycleBin()";
	}
	else if (thisPath == "IE Favorites")
	{
		src = gadgetPath + "\\images\\FavsIE.png";
		execType = "showFavs('ie')";
	}
	else if (thisPath == "Firefox Bookmarks")
	{
		src = gadgetPath + "\\images\\FavsFF.png";
		execType = "showFavs('ff')";
	}
	else if (thisPath == "Opera Bookmarks")
	{
		src = gadgetPath + "\\images\\FavsOP.png";
		execType = "showFavs('op')";
	}
	else if (thisPath == "LauncherDivider")
	{
		src = "/images/divLong.png";
	}
	else if (oFSO.FolderExists(thisPath))
	{
    src = thisPath;
		if (folderSetting != 2)
		{
      dragEnter = "javascript:event.returnValue = false";
      dragOver = "hiliteLink(3);javascript:event.returnValue = false";
      dragLeave = "unHiliteLink(3);javascript:event.returnValue = false";
      dragDrop = "moveToFolder(linksList["+i+"])";
      execType = "execFolder()";
    }
	}
	else
	{
    filePath = thisPath;
		if (!oFSO.FileExists(filePath))
		{
			src = gadgetPath+"\\images\\Error.png";
			execType = "javascript:void(0)";
		}
		else
		{
			src = tmpPath;
			if (dragSetting != 0)
			{
				dragEnter = "javascript:event.returnValue = false";
				dragOver = "hiliteLink(2);javascript:event.returnValue = false";
				dragLeave = "unHiliteLink(2);javascript:event.returnValue = false";
				dragDrop = "fileDropExec()";
			}
			if (switchList[i] != "none")
			{
        execType = "execWithSwitches("+i+")";
			}
		}
	}
		
	if (iconsList[i] != "none")
	{
		src = iconsList[i];
    if (!oFSO.FileExists(src))
    {
      src = gadgetPath+"\\images\\Error.png";
    }
 	}
} catch(err) {debugLog("setFilePaths: "+err.name+" - "+err.message);}
}

function execLink(passLink)
{
try{
  var getLink = event.srcElement;
  var thisPath = getLink.link;
  if (passLink)
  {
    thisPath = passLink;
  }
  
	if (thisPath == "My Computer")
	{
		System.Shell.execute("::{20D04FE0-3AEA-1069-A2D8-08002B30309D}");
	}
	else if (thisPath == "Network")
	{
		System.Shell.execute("::{F02C1A0D-BE21-4350-88B0-7367FC96EF3C}");
	}
	else if (thisPath == "Network VAIO")
	{
		System.Shell.execute("::{7007ACC7-3202-11D1-AAD2-00805FC1270E}");
	}
	else if (thisPath == "Control Panel Category")
	{
		System.Shell.execute("::{26EE0668-A00A-44D7-9371-BEB064C98683}");
	}
	else if (thisPath == "Control Panel Classic")
	{
		System.Shell.execute("::{21EC2020-3AEA-1069-A2DD-08002B30309D}");
	}
	else if (thisPath == "Control Panel VAIO")
	{
		System.Shell.execute("::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\::{21EC2020-3AEA-1069-A2DD-08002B30309D}");
	}
	else if (thisPath == "Internet Explorer")
	{
    System.Shell.execute("::{871C5380-42A0-1069-A2EA-08002B30309D}");
	}
	else
	{
    if (oFSO.FileExists(thisPath) || oFSO.FolderExists(thisPath))
    {
      System.Shell.execute(thisPath);
    }
	}
  getLink.blur();
} catch(err) {debugLog("execLink: "+err.name+" - "+err.message)}
}

function moveToFolder(thisFolder)
{
try{
  var sFile;
  cancelBodyOver = 0;
  for (var i=0 ; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null ; i++)
  {
    sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
    if (oFSO.FolderExists(sFile))
    {
      if (folderSetting == 0)
      {
        oFSO.MoveFolder(sFile, thisFolder+"\\");
      }
      else
      {
        oFSO.CopyFolder(sFile, thisFolder+"\\", false);
      }
    }
    else
    {
      if (folderSetting == 0)
      {
        oFSO.MoveFile(sFile, thisFolder+"\\");
      }
      else
      {
        oFSO.CopyFile(sFile, thisFolder+"\\", false);
      }
    }
  }
}	catch(err)	{debugLog("moveToFolder: "+err.name+" - "+err.message);}
}

function recycleBin()
{
try{
	System.Gadget.Flyout.file = "flyoutRB.html";
	System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
} catch(err) {debugLog("recycleBin: "+err.name+" - "+err.message)}
}

function updateRB()
{
try{
	var link = document.getElementById("rbHere");
	if(link)
	{
		binCount = System.Shell.RecycleBin.fileCount + System.Shell.RecycleBin.folderCount;
		if (binCount == 0)
		{
			link.src = "gimage:///" + rbEmpty + wh;
		}
		else
		{
			link.src = "gimage:///" + rbFull + wh;
		}
	}
} catch(err) {debugLog("updateRB: "+err.name+" - "+err.message)}
}

function showFavs(type)
{
try{
  write("FavMeth", type);
	System.Gadget.Flyout.file = "flyoutFav.html";
	System.Gadget.Flyout.show = !System.Gadget.Flyout.show;
} catch(err) {debugLog("showFavs: "+err.name+" - "+err.message)}
}

function recycleBinDragDropped()
{
try{
  var sFile;
  cancelBodyOver = 0;
  for (var i=0 ; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null ; i++)
  {
    sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
    System.Shell.RecycleBin.deleteItem(sFile);
  }
}	catch(err)	{	debugLog("recycleBinDragDropped: "+err.name+" - "+err.message);	}
}

function fileDropAdd()
{
try{
	if (dragSetting != 1 && System.Shell.itemFromFileDrop(event.dataTransfer, 0) != null)
	{
    var sFile;
		for (var i=0; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null; i++)
		{
			sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
			addOneToList(sFile);
		}
		write("Links", linksList.toString());
		write("Icons", iconsList.toString());
		write("Switches", switchList.toString());
		createLayout();

    var sFilename = gadgetPath + "\\BackMeUp\\filepaths.txt";
    if (oFSO.FileExists(sFilename))
    {
      oFSO.DeleteFile(sFilename, true);
    }
    var oFile = oFSO.CreateTextFile(sFilename, true);
	
    for (var i = 0; i < linksList.length ; i++)
    {
      oFile.WriteLine(linksList[i]);
    }
    oFile.Close();
  }
} catch(err) {debugLog("fileDropAdd: "+err.name+" - "+err.message);}
}

function fileDropExec()
{
try{
  var sFile;
  cancelBodyOver = 0;
	for (var i=0 ; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null ; i++)
	{
		sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
		
		tmpLink = event.srcElement.link;
		
		if (oFSO.FileExists(tmpLink))
		{
      System.Shell.execute(tmpLink, "\""+sFile+"\"", null, "open");
		}
	}
} catch(err) {debugLog("fileDropExec: "+err.name+" - "+err.message)}
}

function execWithSwitches(index)
{
try{
  var thisFile = linksList[index];
  var thisSwitch = switchList[index];
  
	if (oFSO.FileExists(thisFile))
  {
    System.Shell.execute(thisFile, "\""+thisSwitch+"\"");
  }
} catch(err) {debugLog("execWithSwitches: "+err.name+" - "+err.message)}
}

function execFolder()
{
try{
  var getLink = event.srcElement.link;
  if (folderOpenSetting == 1)
  {
    write("folderLocation", getLink);
    showFavs('folder');
  }
  else
  {
    execLink(getLink);
  }
} catch(err) {debugLog("execFolder: "+err.name+" - "+err.message)}
}

function addOneToList(newOne) 
{
try{
	var n = linksList.length;
	linksList[n] = newOne;
	iconsList[n] = "none";
	switchList[n] = "none";
} catch(err) {debugLog("addOneToList: "+err.name+" - "+err.message)}
}

function hiliteLink(hovType)
{
try{
  var img = event.srcElement;
  thisPath = img.link;
  thisTitle = oFSO.GetBaseName(thisPath);
  
  if (dragSetting != 0 && hovType)
  {
    document.body.ondrop = "javascript:event.returnValue = false";
  }
  
  if (oFSO.DriveExists(thisPath))
	{
    d = oFSO.GetDrive(oFSO.GetDriveName(thisPath));
		thisTitle = thisPath+" {"+parseInt(d.FreeSpace/1024/1024/1024)+" GB free}";
	}

  if (img.link != null)
  {
    if (showHighlight=="yes") 
    {
      img.style.backgroundImage = "url(/images/highlight.png)";  // setting off by default
    }
    if (makeIconBigger=="yes") 
    {
      img.style.width = imgLarge;
      img.style.height = imgLarge;
      img.style.msInterpolationMode = "bicubic";
    }
    img.style.cursor = "hand";
        
    if (hovType == 1)
    {
      cancelBodyOver = 1;
      displayThis = "Delete this item.";
    }
    else if (hovType == 2)
    {
      cancelBodyOver = 1;
      displayThis = "Open with " + thisTitle + ".";
    }
    else if (hovType == 3)
    {
      cancelBodyOver = 1;
      if (folderSetting == 0)
      {
        displayThis = "Move to " + thisTitle + ".";
      }
      else
      {
        displayThis = "Copy to " + thisTitle + ".";
      }
    }
    else
    {
      displayThis = thisTitle;
      if(thisPath == "Recycle Bin")
      {
        rbCount = System.Shell.RecycleBin.fileCount + " files, " + System.Shell.RecycleBin.folderCount + " folders";
        displayThis = rbCount;
      }
    }
    if (infoSetting == 1)
    {
      document.getElementById("appInfo").innerText=displayThis;
    }
  }
  else
  {
    event.returnValue = false;
  }
} catch(err) {debugLog("HiliteLinks: "+err.name+" - "+err.message)}
}

function unHiliteLink(hovType)
{
try{
  var img = event.srcElement;

  document.body.ondrop = fileDropAdd;
  
  if (img.link != null)
  {
    img.style.backgroundImage = "";
    if (makeIconBigger=="yes") 
    {
      img.style.width = imgSmall;
      img.style.height = imgSmall;
      img.style.msInterpolationMode = "bicubic";
    }
    img.style.cursor = "default";
    document.getElementById("appInfo").innerText = "";
    cancelBodyOver = 0;
  }
  else
  {
    event.returnValue = false;
  }
} catch(err) {debugLog("UnhiliteLinks: "+err.name+" - "+err.message)}
}

function settingsClosed(event)
{
try{
  setRbIcons();
	var linksString = read("Links");
	var iconsString = read("Icons");
	var switchString = read("Switches");
	targetLink = read("TargetLink");
	perRowSetting = read("PerRowSetting");
	dragSetting = read("DragSetting");
	bgSetting = read("BgSetting");
	infoSetting = read("InfoSetting");
	folderSetting = read("FolderSetting");
	centreSetting = read("CentreSetting");
	folderOpenSetting = read("FolderOpenSetting");
	filterExtSetting = read("FilterExtSetting");
	if (linksString != "none")
	{   
		linksList = linksString.split(",", linksString.length);
		iconsList = iconsString.split(",", linksString.length);
		switchList = switchString.split(",", linksString.length);
	} 
	else
	{
    linksList = new Array();
    iconsList = new Array();
    switchList = new Array();
	}
	cancelBodyOver = 0;
	createLayout();
} catch(err) {debugLog("SettingsClosed: "+err.name+" - "+err.message)}
}

function setRbIcons()
{
try{
	if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\rbSettings.txt"))
	{	
    defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\rbSettings.txt", 1, false);
		rbEmpty = defaultFile.ReadLine();
		rbFull = defaultFile.ReadLine();
		defaultFile.Close();
	}
} catch(err) {debugLog("SetRbIcons: "+err.name+" - "+err.message)}
}

function addTipOver()
{
try{
  if (dragSetting != 1)
  {
    if ( cancelBodyOver == 0)  // this cancels the ondragover when over an icon
    {
      document.getElementById("appInfo").innerText="Add to launcher.";
    }
  }
  event.returnValue = false;
} catch(err) {debugLog("addTipOver: "+err.name+" - "+err.message)}
}

function addTipOut()
{
try{
  document.getElementById("appInfo").innerText="";
  event.returnValue = false
} catch(err) {debugLog("addTipOut: "+err.name+" - "+err.message)}
}

function createTestFile(data1,data2,data3,data4)
{
	var sFilename = gadgetPath + "\\BackMeUp\\test.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	var oFile = oFSO.CreateTextFile(sFilename, true);
	
	oFile.WriteLine(data1);
	oFile.WriteLine(data2);
	oFile.WriteLine(data3);
	oFile.WriteLine(data4);
	
	oFile.Close();
}

function isValidPath(str) 
{
try{
               //   WIN PATH                       |        NETWORK PATH    
  var regexp = /(^[A-Za-z]:(\\|\\[^\/:\*\?\"<>\|]+)|^\\\\([^\\\/:\*\?\"<>\|]+)\\([^\/:\*\?\"<>\|]+))$/;
  return regexp.exec(str);
} catch(err) {debugLog("isValidPath: "+err.name+" - "+err.message)}
}

