// copyright 2007 Dean Laforet, Simon Paterson
// do not use or modify code without permission.

var oShell = new ActiveXObject("WScript.Shell");
var oFSO = new ActiveXObject("Scripting.FileSystemObject");

var winPath = System.Environment.getEnvironmentVariable("WINDIR");
var pfPath = System.Environment.getEnvironmentVariable("PROGRAMFILES");
if (oFSO.FolderExists(pfPath+" (x86)")) pfPath = pfPath+" (x86)";
var	myComp = winPath+"\\explorer.exe";
var	control = winPath+"\\system32\\control.exe";
var	ie = pfPath+"\\Internet Explorer\\iexplore.exe";
var gadgetPath = System.Gadget.path;
var errorImage = gadgetPath+"\\images\\Error.png";
var network = gadgetPath+"\\images\\network.ico";
var rbEmpty = gadgetPath+"\\images\\rbEmpty.ico";
var rbFull = gadgetPath+"\\images\\rbFull.ico";
var wh = "?width=20&height=20";
var tmpArray = new Array();
var iconArray = new Array();
var switchArray = new Array();

var bDebug = oFSO.FileExists(gadgetPath+"\\debugset.txt");
try{
	if (bDebug)
		var debugLogFile = oFSO.OpenTextFile(gadgetPath+"\\debugset.txt", 2);
} catch(err) {bDebug = false; debugLog("Open debug.txt error"+err.name+" - "+err.message)}

function debugLog(outStr) {
	try{
		System.Debug.outputString(outStr);
		if (bDebug)
			debugLogFile.WriteLine(outStr);
	} catch(err) {}
}

onerror = function(msg,url,l) 
{
	debugLog("Javascript error: "+msg+" - on line: "+l);
}

document.onreadystatechange = function()
{    
  if(document.readyState=="complete")
  {
	try{
		getSettings();
	
		if (linksList == "none" || linksList == "")
		{
			DisplayNoLinks(true);
		}
		else
		{
			DisplayNoLinks(false);
			bldShortCuts();
		}
		setBgColor();
		setRbIcons();
    document.getElementById("rbEmptyIcon").src = "gimage:///" + rbEmpty + "?width=32&height=32";
    document.getElementById("rbFullIcon").src = "gimage:///" + rbFull + "?width=32&height=32";
    countBackgrounds();
	} catch(err) {debugLog("LoadSettings: "+err.name+" - "+err.message)}
	}
}

System.Gadget.onSettingsClosing = function(event)
{
	if (event.closeAction == event.Action.commit)
	{
    saveShortcuts();
		write("Links", tmpArray.toString());
		write("Icons", iconArray.toString());
		write("Switches", switchArray.toString());
		write("TargetLink", linkSelect.options.selectedIndex);
		write("PerRowSetting", perRowSelect.options.selectedIndex);
		write("DragSetting", dragSelect.options.selectedIndex);
		write("BgSetting", bgSetting);
		write("InfoSetting", infoSelect.options.selectedIndex);
		write("FolderSetting", folderSelect.options.selectedIndex);
		write("CentreSetting", centreSelect.options.selectedIndex);
		write("SettingsTipsSetting", settingsTipsSelect.options.selectedIndex);
		write("FolderOpenSetting", folderOpenSelect.options.selectedIndex);
		write("FilterExtSetting", filterExtSelect.options.selectedIndex);
	}
	event.cancel = false;
}

function read(name)
{
  value = System.Gadget.Settings.read(name);
  return value;
}

function write(name,value)
{
  System.Gadget.Settings.write(name, value);
}

function getSettings()
{
try{
	targetLink = read("TargetLink");
	perRowSetting = read("PerRowSetting");
	dragSetting = read("DragSetting");
	bgSetting = read("BgSetting");
	infoSetting = read("InfoSetting");
	folderSetting = read("FolderSetting");
	centreSetting = read("CentreSetting");
	settingsTipsSetting = read("SettingsTipsSetting");
	folderOpenSetting = read("FolderOpenSetting");
	filterExtSetting = read("FilterExtSetting");
	linkSelect.options.selectedIndex = targetLink;
	perRowSelect.options.selectedIndex = perRowSetting;
	dragSelect.options.selectedIndex = dragSetting;
	infoSelect.options.selectedIndex = infoSetting;
	folderSelect.options.selectedIndex = folderSetting;
	centreSelect.options.selectedIndex = centreSetting;
	settingsTipsSelect.options.selectedIndex = settingsTipsSetting;
	folderOpenSelect.options.selectedIndex = folderOpenSetting;
	filterExtSelect.options.selectedIndex = filterExtSetting;
	
	var linksString = read("Links");
	var iconsString = read("Icons");
	var switchString = read("Switches");
	if (linksString != "none" || linksString != "" )
	{   
		linksList = linksString.split(",", linksString.length);
		iconsList = iconsString.split(",", iconsString.length);
		switchList = switchString.split(",", switchString.length);
		tmpArray = linksList;
		iconArray = iconsList;
		switchArray = switchList;
		checkDefaults();
	} 
	else
	{
		linksList = new Array();
		iconsList = new Array();
		switchList = new Array();
	}
	if (settingsTipsSetting == 1)
	{
    removeToolTips();
  }  
} catch(err) {debugLog("getSettings: "+err.name+" - "+err.message)}
}

function checkDefaults()
{
try{
	var isMyC; var isNet; var isCPcla; var isCPcat; var isIE; var isRB; var isFavIE; var isFavFire; var isFavOp;
	for (var i = 1;i < 10 ; i++)
	{
		document.getElementById('sp'+i).checked = false;
	}
	
	for (var i = 0;i < tmpArray.length ; i++)
	{
		var testIt = tmpArray[i];
		if (testIt == "My Computer") { isMyC = true; }
		if (testIt == "Network") { isNet = true;}
		if (testIt == "Control Panel Classic") { isCPcla = true; }
		if (testIt == "Control Panel Category") { isCPcat = true; }
		if (testIt == "Internet Explorer") { isIE = true; }
		if (testIt == "Recycle Bin") { isRB = true; }
		if (testIt == "IE Favorites") { isFavIE = true; }
		if (testIt == "Firefox Bookmarks") { isFavFire = true; }
		if (testIt == "Opera Bookmarks") { isFavOp = true; }
	}
	
	if (isMyC) { document.getElementById('sp1').style.display = "none";	}else{ document.getElementById('sp1').style.display = "";}
	if (isNet) { document.getElementById('sp2').style.display = "none";	}else{ document.getElementById('sp2').style.display = "";}
	if (isCPcat) { document.getElementById('sp3').style.display = "none";	}else{ document.getElementById('sp3').style.display = "";}
	if (isCPcla) { document.getElementById('sp4').style.display = "none";	}else{ document.getElementById('sp4').style.display = "";}
	if (isIE) { document.getElementById('sp5').style.display = "none";	}else{ document.getElementById('sp5').style.display = "";}
	if (isRB) { document.getElementById('sp6').style.display = "none";	}else{ document.getElementById('sp6').style.display = "";}
	if (isFavIE) { document.getElementById('sp7').style.display = "none";	}else{ document.getElementById('sp7').style.display = "";}
	if (isFavFire) { document.getElementById('sp8').style.display = "none";	}else{ document.getElementById('sp8').style.display = "";}
	if (isFavOp) { document.getElementById('sp9').style.display = "none";	}else{ document.getElementById('sp9').style.display = "";}
	
} catch(err) {debugLog("checkDefaults: "+err.name+" - "+err.message)}
}

function getFocus() { self.focus(); }

function DisplayNoLinks(tf)
{
try{
	var t1 = null;
	if (tf)
	{
		iViewList.style.display = "none";
		idNoShortcutList.style.display = "";
		document.getElementById("L_REMOVE").disabled=true;
		document.getElementById("L_CHANGE").disabled=true;
		document.getElementById("L_RESET").disabled=true;
		document.getElementById("L_ARG").disabled=true;
		setTimeout("getFocus()", 300);
	}
	else
	{
		iViewList.style.display  = "";
		idNoShortcutList.style.display = "none";
		document.getElementById("L_REMOVE").disabled=false;       
		document.getElementById("L_CHANGE").disabled=false;       
		document.getElementById("L_RESET").disabled=false;       
		document.getElementById("L_ARG").disabled=false;       
		setTimeout("getFocus()", 300);
	}
} catch(err) {debugLog("DisplayNoLinks: "+err.name+" - "+err.message)}
}

function bldShortCuts()
{
try{
	img = null;
	thisPath = null;
	arFileName = null;
	while (iItemTbl.rows.length > 0) { iItemTbl.deleteRow(0); }
	for (var i = 0;i < tmpArray.length ; i++)
	{
    if (tmpArray[i] != null)
    {
      getFilePaths(i);
      
      showArg = switchArray[i];
      if (showArg == "none")
      {
        showArg = "";
      }
      argLabel = "Commands to pass to " + label;
      if (allowSwitch == "no")
      {
        argLabel = "You can not set arguments for this object.";
      }
      
			row = iItemTbl.insertRow(i);  
             
			cell = row.insertCell();
			cell.setAttribute("vAlign", "top");
			id = "r"+ i + "c0";

      if (i == (tmpArray.length-1)) showDown = '<img src="images/blank.png" />';
      else showDown = '<img src="images/down.png" onclick="moveDown('+i+');" onmouseover="overIt();" onmouseout="notOverIt();" />';
      if (i == 0) showUp = '<img src="images/blank.png" />';
      else showUp = '<img src="images/up.png" onclick="moveUp('+i+');" onmouseover="overIt();" onmouseout="notOverIt();" />';
			
			cell.innerHTML = showUp + "&nbsp;" + showDown + "&nbsp;<input type=\"checkbox\" id=\"" + id + "\" onfocus=\"blur();\" />";
			cell.setAttribute("width","55px");
			
			cell = row.insertCell();
			id = "r"+i + "c1";
			var oImg = document.createElement("img");
			oImg.src = img;
			oImg.title = label;
			oImg.width = 20;
			oImg.height = 20;
			cell.appendChild(oImg);
			cell.setAttribute("vAlign","top");
			cell.width = 20;
			
			cell = row.insertCell();
			id = "r"+ i + "c3";
			var oSpan = document.createElement("span");
			oSpan.id = id;
			oSpan.className = "spanFld";
			oSpan.setAttribute("title",thisPath);
			oSpan.setAttribute("link",allowSwitch);
			oSpan.innerText = label;
			cell.appendChild(oSpan);
			cell.setAttribute("vAlign","top");	
			cell.setAttribute("nowrap");
			
			cell = row.insertCell();
			id = "r"+ i + "c4";
			var oSpan = document.createElement("span");
			oSpan.id = id;
			oSpan.className = "argFld";
			oSpan.setAttribute("title",argLabel);
			oSpan.innerText = showArg;
			cell.appendChild(oSpan);
			cell.setAttribute("vAlign","top");	
			cell.setAttribute("nowrap");
		}
	}
} catch(err) {debugLog("bldShortCuts: "+err.name+" - "+err.message)}
}

function getFilePaths(i)
{
try{
  allowSwitch = "yes";
	thisPath = tmpArray[i];
	filePath = thisPath;
	label = oFSO.GetFileName(thisPath);
			
	if (label == "")
	{
		label = "Drive - "+thisPath;
	}

	if (thisPath == "My Computer")
	{
		filePath = "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}";
		label = thisPath;
		img = myComp;
	}
	else if (thisPath == "Network")
	{
		filePath = "::{F02C1A0D-BE21-4350-88B0-7367FC96EF3C}";
		label = thisPath;
		img = network;
    allowSwitch = "no";
	}
	else if (thisPath == "Network VAIO")
	{
		filePath = "::{7007ACC7-3202-11D1-AAD2-00805FC1270E}";
		label = thisPath;
		img = network;
    allowSwitch = "no";
	}
	else if (thisPath == "Control Panel Category")
	{
		filePath = "::{26EE0668-A00A-44D7-9371-BEB064C98683}";
		label = thisPath;
		img = control;
    allowSwitch = "no";
	}
	else if (thisPath == "Control Panel Classic")
	{
		filePath = "::{21EC2020-3AEA-1069-A2DD-08002B30309D}";
		label = thisPath;
		img = control;
    allowSwitch = "no";
	}
	else if (thisPath == "Control Panel VAIO")
	{
		filePath = "::{20D04FE0-3AEA-1069-A2D8-08002B30309D}\\::{21EC2020-3AEA-1069-A2DD-08002B30309D}";
		label = thisPath;
		img = control;
    allowSwitch = "no";
	}
	else if (thisPath == "Internet Explorer")
	{
		filePath = "::{871C5380-42A0-1069-A2EA-08002B30309D}";
		label = thisPath;
		img = ie;
    allowSwitch = "no";
	}
	else if (thisPath == "Recycle Bin")
	{
		filePath = "::{645FF040-5081-101B-9F08-00AA002F954E}";
    label = thisPath;
    img = rbEmpty;
    allowSwitch = "no";
	}
	else if (thisPath == "IE Favorites")
	{
		label = thisPath;
		img = gadgetPath + "\\images\\FavsIE.png";
    allowSwitch = "no";
	}
	else if (thisPath == "Firefox Bookmarks")
	{
		label = thisPath;
		img = gadgetPath + "\\images\\FavsFF.png";
    allowSwitch = "no";
	}
	else if (thisPath == "Opera Bookmarks")
	{
		label = thisPath;
		img = gadgetPath + "\\images\\FavsOP.png";
    allowSwitch = "no";
	}
	else if (thisPath == "LauncherDivider")
	{
		label = thisPath;
		img = gadgetPath + "\\images\\divSmall.png";
    allowSwitch = "no";
	}
	else
	{
    img = thisPath;
		if (!oFSO.FileExists(thisPath))
		{
      if (!oFSO.FolderExists(thisPath))
      {
        img = errorImage;
        allowSwitch = "no";
        label = "file deleted or moved";
      }
		}
	}
			
	if (iconsList[i] != "none")
	{
		img = iconArray[i];
    if (!oFSO.FileExists(img))
    {
      img = errorImage;
      label = "icon missing";
    }
 	}
	img = "gimage:///" + img + wh;
	
} catch(err) {debugLog("getFilePaths: "+err.name+" - "+err.message)}
}

function delLinks()
{
try{
	var index = 0;
	var startLength = tmpArray.length;
	tmpArray.splice(0,tmpArray.length);
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		id = "r"+i+"c0";
		if (!document.getElementById(id).checked)
		{
			tmpArray[index] = document.getElementById("r"+i+"c3").title;
			iconArray[index] = iconArray[i];
			switchArray[index] = switchArray[i];
			index++;
		}
	}
	if (tmpArray.length == 0)
	{
		DisplayNoLinks(true);
		tmpArray = "none";
	}
	else
	{
		bldShortCuts();
		DisplayNoLinks(false);
		checkDefaults();
	}    
	var endLength = tmpArray.length;
	if (startLength == endLength)
	{
    document.getElementById("warning").innerText="You must select an item to remove it.";
  }
  else
  {
    document.getElementById("warning").innerText="Add any object by dragging it to the list.";
  }
} catch(err) {debugLog("delLinks: "+err.name+" - "+err.message)}
}

function browseFile()  /// not used any more
{
try{
  document.getElementById("warning").innerText="Add any object by dragging it to the list.";
	var oItem = System.Shell.chooseFile(true, "All Files:*.*::", "", "");
	if (oItem) 
	{
    var addPath = oItem.path;
    addToArray(addPath);
    bldShortCuts(); 
  }
} catch(err) {debugLog("browseFile: "+err.name+" - "+err.message)}
}

function addToArray(addThis)
{
try{
  if (tmpArray=="none" || tmpArray == "")
  {
		tmpArray = new Array();
		iconArray = new Array();
		switchArray = new Array();
	}
  var n = tmpArray.length;
	tmpArray[n] = addThis;
	iconArray[n] = "none";
	switchArray[n] = "none";
} catch(err) {debugLog("addToArray: "+err.name+" - "+err.message)}
}

function addDivide()
{
try{
  addToArray("LauncherDivider");
	bldShortCuts(); 
 	DisplayNoLinks(false);
} catch(err) {debugLog("addDivide: "+err.name+" - "+err.message)}
}

function changeIco()
{
try{
	var index = 0;
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		id = "r"+i+"c0";
		if (document.getElementById(id).checked) 
		{
			index++;
			var ChangeThisFilesIcon = tmpArray[i];
			var location = i;
		}							
	}		

	if (index == 1)
	{
		if (ChangeThisFilesIcon != "Recycle Bin")
		{
			var oItem = System.Shell.chooseFile(true, "Icon Files:*.ico;*.png;*.exe::", "", "");
			if (oItem) 
			{
				iconArray[location] = oItem.path;
				bldShortCuts(); 
				DisplayNoLinks(false);
        document.getElementById("warning").innerText="Add any object by dragging it to the list.";
			}
		}
		else
		{
      document.getElementById("warning").innerText="Click the Layout tab to change this.";
		}
	}
	
	if (index == 0)
	{
    document.getElementById("warning").innerText="First select an item to change it's icon.";
	}
	if (index > 1)
	{
    document.getElementById("warning").innerText="Select only one item at a time.";
	}
} catch(err) {debugLog("changeIco: "+err.name+" - "+err.message)}
}

function resetIco()
{
try{
	var index = 0;
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		id = "r"+i+"c0";
		if (document.getElementById(id).checked) 
		{
			index++;
      iconArray[i] = "none";
		}							
	}		
	if (index > 0) 
	{
		bldShortCuts(); 
		DisplayNoLinks(false);
    document.getElementById("warning").innerText="Icons reset to original state.";
	}
	if (index == 0)
	{
    document.getElementById("warning").innerText="First select the items you want to reset.";
	}
} catch(err) {debugLog("resetIco: "+err.name+" - "+err.message)}
}

function moveDown(thisOne) {
try{
	if (thisOne < tmpArray.length)
	{
    switchThem(thisOne);
	}
	bldShortCuts();
	DisplayNoLinks(false);
} catch(err) {debugLog("moveDown: "+err.name+" - "+err.message)}
}

function moveUp(thisOne) {
try{
	if (thisOne > 0)
	{
    thisOne = thisOne-1;
    switchThem(thisOne);
	}
	bldShortCuts();
	DisplayNoLinks(false);
} catch(err) {debugLog("moveUp: "+err.name+" - "+err.message)}
}

function switchThem(thisOne)
{
try{
	var index = 0;
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		if (i == thisOne)
		{
      var linkTemp = tmpArray[index];
			var iconTemp = iconArray[index];
			var switchTemp = switchArray[index];
			tmpArray[index] = tmpArray[i+1]; 
			iconArray[index] = iconArray[i+1];
			switchArray[index] = switchArray[i+1];
			index++;
			tmpArray[index] = linkTemp; 
			iconArray[index] = iconTemp;
			switchArray[index] = switchTemp;
			i++;     
		}
		index++;
	}
} catch(err) {debugLog("switchThem: "+err.name+" - "+err.message)}
}

function overIt()
{
	var img = event.srcElement;
	img.style.cursor = "hand";
}

function notOverIt()
{
	var img = event.srcElement;
	img.style.cursor = "default";
}

function clearMenu()
{
	defaults.style.display = "none";
	style.style.display = "none";
	save.style.display = "none";
	misc.style.display = "none";
	reorder.style.display = "none";
	menu1.style.borderBottomColor = "#505050";
	menu2.style.borderBottomColor = "#505050";
	menu3.style.borderBottomColor = "#505050";
	menu4.style.borderBottomColor = "#505050";
	menu5.style.borderBottomColor = "#505050";
}

function menuA()
{
  clearMenu();
	reorder.style.display = "";
	menu1.style.borderBottomColor = "#f0f0f0";
}

function menuB()
{
  clearMenu();
	style.style.display = "";
	menu2.style.borderBottomColor = "#f0f0f0";
	checkDefaults();
}

function menuC()
{
  clearMenu();
	defaults.style.display = "";
	menu3.style.borderBottomColor = "#f0f0f0";
}

function menuD()
{
  clearMenu();
	misc.style.display = "";
	menu4.style.borderBottomColor = "#f0f0f0";
	checkDefaults();
}

function menuE()
{
  clearMenu();
	save.style.display = "";
	menu5.style.borderBottomColor = "#f0f0f0";
}

function updateDef()
{
try{
	for (var i = 1; i < 10 ; i++)
	{
		id = "sp"+i;
		if (document.getElementById(id).checked)
		{
      addThis = document.getElementById("sp"+i+"name").innerText;
      addToArray(addThis);
		}
	}
	checkDefaults();
	bldShortCuts();
	DisplayNoLinks(false);
} catch(err) {debugLog("updateDef: "+err.name+" - "+err.message)}
}

function fileDragDropped()
{
try{
	var sFile;
	for (var i=0 ; System.Shell.itemFromFileDrop(event.dataTransfer, i) != null ; i++)
	{
		sFile = System.Shell.itemFromFileDrop(event.dataTransfer, i).path;
    addToArray(sFile);
	}
	bldShortCuts();  
	DisplayNoLinks(false);
}	catch(err)	{debugLog("fileDragDropped: "+err.name+" - "+err.message)}
}

function openGadgetFolder()
{
try{
	System.Shell.execute(gadgetPath+"\\BackMeUp");
} catch(err) {debugLog("openGadgetFolder: "+err.name+" - "+err.message)}
}

function openBgFolder()
{
try{
	System.Shell.execute(gadgetPath+"\\images\\backgrounds");
} catch(err) {debugLog("openBgFolder: "+err.name+" - "+err.message)}
}

function saveShortcuts()
{
try{
	var sFilename = gadgetPath + "\\BackMeUp\\filepaths.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	var oFile = oFSO.CreateTextFile(sFilename, true);
	
	for (var i = 0; i < tmpArray.length ; i++)
	{
		oFile.WriteLine(tmpArray[i]);
	}
	oFile.Close();
	
	var sFilename = gadgetPath + "\\BackMeUp\\iconpaths.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	var oFile = oFSO.CreateTextFile(sFilename, true);
	
	for (var i = 0; i < tmpArray.length ; i++)
	{
		oFile.WriteLine(iconArray[i]);
	}
	oFile.Close();

	var sFilename = gadgetPath + "\\BackMeUp\\switchpaths.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	var oFile = oFSO.CreateTextFile(sFilename, true);
	
	for (var i = 0; i < tmpArray.length ; i++)
	{
		oFile.WriteLine(switchArray[i]);
	}
	oFile.Close();
		
	var sFilename = gadgetPath + "\\BackMeUp\\settings.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	targetLink = linkSelect.options.selectedIndex;
	perRowSetting = perRowSelect.options.selectedIndex;
	dragSetting = dragSelect.options.selectedIndex;
	infoSetting = infoSelect.options.selectedIndex;
	folderSetting = folderSelect.options.selectedIndex;
	centreSetting = centreSelect.options.selectedIndex;
	settingsTipsSetting = settingsTipsSelect.options.selectedIndex;
	folderOpenSetting = folderOpenSelect.options.selectedIndex;
	filterExtSetting = filterExtSelect.options.selectedIndex;
	var oFile = oFSO.CreateTextFile(sFilename, true);
	oFile.WriteLine(targetLink);
	oFile.WriteLine(perRowSetting);
	oFile.WriteLine(dragSetting);
	oFile.WriteLine(bgSetting);
	oFile.WriteLine(infoSetting);
	oFile.WriteLine(folderSetting);
	oFile.WriteLine(centreSetting);
	oFile.WriteLine(settingsTipsSetting);
	oFile.WriteLine(folderOpenSetting);
	oFile.WriteLine(filterExtSetting);
	oFile.Close();
} catch(err) {debugLog("saveShortcuts: "+err.name+" - "+err.message)}
}

function changeRbIcon(whichOne)
{
try{
	var oItem = System.Shell.chooseFile(true, "Icon Files:*.ico;*.png;*.exe::", "", "");
	if (oItem) 
	{
    if (whichOne == "empty")
    {
      rbEmpty = oItem.path;
      document.getElementById("rbEmptyIcon").src = "gimage:///" + rbEmpty + "?width=32&height=32";
    }
    else
    {
      rbFull = oItem.path;
      document.getElementById("rbFullIcon").src = "gimage:///" + rbFull + "?width=32&height=32";
    }
  }
  saveRbSettings();
} catch(err) {debugLog("changeRbEmptyIcon: "+err.name+" - "+err.message)}
}

function saveRbSettings()
{
try{
	var sFilename = gadgetPath + "\\BackMeUp\\rbSettings.txt";
	if (oFSO.FileExists(sFilename))
	{
		oFSO.DeleteFile(sFilename, true);
	}
	var oFile = oFSO.CreateTextFile(sFilename, true);
	oFile.WriteLine(rbEmpty);
	oFile.WriteLine(rbFull);
	oFile.Close();
} catch(err) {debugLog("saveRbSettings: "+err.name+" - "+err.message)}
}

function setRbIcons()
{
try{
	if (oFSO.FileExists(gadgetPath+"\\BackMeUp\\rbSettings.txt"))
	{	
    defaultFile = oFSO.OpenTextFile(gadgetPath+"\\BackMeUp\\rbSettings.txt", 1, false);
		rbEmpty = defaultFile.ReadLine();
		rbFull = defaultFile.ReadLine();
		defaultFile.Close();
	}
} catch(err) {debugLog("setRbIcons: "+err.name+" - "+err.message)}
}

function resetRbIco()
{
try{
  rbEmpty = gadgetPath+"\\images\\rbEmpty.ico";
  rbFull = gadgetPath+"\\images\\rbFull.ico";
  document.getElementById("rbEmptyIcon").src = "gimage:///" + rbEmpty + "?width=32&height=32";
	document.getElementById("rbFullIcon").src = "gimage:///" + rbFull + "?width=32&height=32";
  saveRbSettings();
} catch(err) {debugLog("resetRbIco: "+err.name+" - "+err.message)}
}

function nextBG()
{
  bgSetting = bgSetting + 1;
  if (bgSetting == (numBGs + 1)) {bgSetting = 1;}
  setBgColor();
}

function prevBG()
{
  bgSetting = bgSetting - 1;
  if (bgSetting == 0) {bgSetting = numBGs;}
  setBgColor();
}

function setBgColor()
{
  bgPath = "url(/images/backgrounds/bg" + bgSetting + ".jpg)";
  document.getElementById("bgPreview").style.backgroundImage = bgPath;
}

function countBackgrounds()
{
try{
  numBGs = 31;
  while (oFSO.FileExists(gadgetPath + "\\images\\backgrounds\\bg" + numBGs + ".jpg"))
  {
    numBGs++;
  }
  numBGs--;
} catch(err) {debugLog("countBackgrounds: "+err.name+" - "+err.message)}
}

function addArguments()
{
try{
	var index = 0;
	argLocation = null;
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		id = "r"+i+"c0";
		if (document.getElementById(id).checked) 
		{
			index++;
			var allowSwitch = document.getElementById("r"+i+"c3").link;
			argLocation = i;
		}							
	}		

	if (index == 1 && allowSwitch == "yes")
	{
    thisName = tmpArray[argLocation];
    label = oFSO.GetFileName(thisName);
    appName.innerText = label;
    commands.style.display = "";
    if (switchArray[argLocation] != "none")
    {
      commandInput.value = switchArray[argLocation];
    }
    else
    {
      commandInput.value = "";
    }
	}

	if (index == 1 && allowSwitch == "no")
	{
    document.getElementById("warning").innerText="You can not set arguments for this object.";
  }
	if (index == 0)
	{
    document.getElementById("warning").innerText="First select an item to add arguments.";
	}
	if (index > 1)
	{
    document.getElementById("warning").innerText="Select only one item at a time.";
	}
} catch(err) {debugLog("addArguments: "+err.name+" - "+err.message)}
}

function setArg()
{
try{
  if (commandInput.value != "")
  {
    switchArray[argLocation] = commandInput.value;
  }
  else
  {
    switchArray[argLocation] = "none";
  }
  
  commandInput.value = "";
	commands.style.display = "none";
	bldShortCuts();
	DisplayNoLinks(false);
} catch(err) {debugLog("setArg: "+err.name+" - "+err.message)}
}

function cancelSetArg()
{
  commandInput.value = "";
	commands.style.display = "none";
	uncheckAll();
}

function uncheckAll()
{
	for (var i = 0; i < iItemTbl.rows.length ; i++)
	{
		id = "r"+i+"c0";
		document.getElementById(id).checked = false;
  }
}

function removeToolTips()
{
	document.getElementById("L_REMOVE").title="";
	document.getElementById("L_CHANGE").title="";
	document.getElementById("L_RESET").title="";
	document.getElementById("L_ARG").title="";
	document.getElementById("L_RB").title="";
	document.getElementById("L_DIV").title="";
	document.getElementById("L_SPEC").title="";
	document.getElementById("L_SETARG").title="";
	document.getElementById("L_CARG").title="";
	document.getElementById("L_BGFLD").title="";
	document.getElementById("L_COUNT").title="";
	document.getElementById("L_GFLD").title="";
	document.getElementById("L_PBG").title="";
	document.getElementById("L_NBG").title="";
}

